<template>
  <div class="reset-pass">
    <h2 class="title">Reset password</h2>
    <div class="desc">
      Enter your email to help us identify you.
    </div>
    <form class="reset-pass__form" @submit.prevent="resetPass">

      <!-- name -->
      <v-input  name="Email"
                type="email"
                v-model="user.email"
                @change="updateUserEmail"
                :isError="$v.user.email.$error">
        <template slot="error">
          <div class="error" v-if="!$v.user.email.required">Email is required</div>
        </template>
      </v-input>

      <!-- reCaptcha -->
      <vue-recaptcha  class="re-captcha"
                      ref="recaptcha"
                      :sitekey="sitekey"
                      :loadRecaptchaScript="true"
                      @verify="verify"
                      @expired="onCaptchaExpired">
      </vue-recaptcha>

      <!-- buttons -->
      <div class="reset-pass__btn-wrapper">
        <button class="btn" type="submit" name="Reset password">
          Reset password
        </button>
        <button class="btn btn--ghostOrange" type="button" name="Resend link">
          Resend link
        </button>
      </div>
    </form>
  </div>
</template>

<script>
import Input from '@/components/Input';
import VueRecaptcha from 'vue-recaptcha';
import call from '@/services/callService';
import {mapMutations} from 'vuex';
import {required} from 'vuelidate/lib/validators';
const touchMap = new WeakMap();

export default {
  name: 'Log',
  data() {
    return {
      user: {
        email: ''
      },
      sitekey: '6LfPIgYTAAAAACEcTfYjFMr8y3GX6qYVLoK-2dML',
      pwdUrl: 'http://localhost:8080/#/resetpwd&key=',
      captchaResponse: null
    }
  },
  validations: {
    user: {
      email: {
        required
      }
    },
    captchaResponse: {
      required
    }
  },
  components:{
    'v-input': Input,
    VueRecaptcha
  },
  methods: {
    ...mapMutations(['UPDATE_AUTH_COMPONENT']),
    updateUserEmail(val) {
      this.delayTouch(this.$v.user.email);
      this.user.email = val;
    },
    verify(recaptchaToken) {
      this.captchaResponse = recaptchaToken;
    },
    onCaptchaExpired() {
      this.$refs.recaptcha.reset();
    },
    async sendResetPwdEmail(params) {
      return await call.sendResetPwdEmail(params);
    },
    async resetPass() {
      let disabled = false;
      this.$v.user.email.$touch();
      if (this.$v.user.email.$error || this.$v.captchaResponse.$invalid) {
        return 0;
      }
      const params = {
        email: this.user.email,
        pwdUrl: this.pwdUrl,
        sitekey: this.sitekey,
        captchaResponse: this.captchaResponse
      };
      if (!disabled) {
        disabled = true;
        this.sendResetPwdEmail(params)
          .then((response) => {
            console.log("An email has been sent to your mailbox, please click the link in the email to change your password.", response);
            this.$notify({
              group: 'app',
              type:'success',
              text: 'An email has been sent to your mailbox, please click the link in the email to change your password.'
            });
            this.UPDATE_AUTH_COMPONENT({isShown: false});
          })
          .catch ((err) => {
            const message = err.desc || JSON.stringify(err);
            console.error("EM Reset Password Error:" + message);
            this.$notify({
              group: 'app',
              type:'error',
              text: message
            });
          })
          .finally(() => {
            this.onCaptchaExpired();
            disabled = false;
          });
      }
    },
    delayTouch($v) {
      $v.$reset();
      if (touchMap.has($v)) {
        clearTimeout(touchMap.get($v));
      }
      touchMap.set($v, setTimeout($v.$touch, 1000));
    }
  },
  computed: {
    typePassword() {
      return (this.showPass) ? 'text' : 'password';
    }
  }
}
</script>

<style lang="sass" scoped>
.title
  font-family: $mainFont
  font-size: rem(32)
  line-height: 1.2
  margin: rem(70) 0 rem(18)
  text-align: left
.desc
  color: #636e7e
  font-family: $mainFont
  font-size: 1rem
  font-weight: 500
  line-height: 1.13
  text-align: left
  margin: 0 0 rem(58)
.re-captcha
  margin-top: rem(22)
.reset-pass
  &__form
    margin-top: rem(50)
    .input
      margin-top: rem(36)
  &__btn-wrapper
    display: flex
    flex-direction: row
    margin-top: rem(26)
    .btn
      margin-right: rem(20)
</style>
